searchNodes=[{"doc":"This module requires the ezprofiler escript, see... https://hexdocs.pm/ezprofiler/api-reference.html https://github.com/nhpip/ezprofiler.git https://hex.pm/packages/ezprofiler Please see documentation for CodeProfiler in ezprofiler . https://hexdocs.pm/ezprofiler/EZProfiler.CodeProfiler.html","ref":"EZProfiler.CodeProfiler.html","title":"EZProfiler.CodeProfiler","type":"module"},{"doc":"This module requires the ezprofiler escript, see... https://github.com/nhpip/ezprofiler.git https://hex.pm/packages/ezprofiler https://hexdocs.pm/ezprofiler/api-reference.html This module provides the ability to perform code profiling programmatically within an application rather than via the ezprofiler CLI. This maybe useful in environments where shell access maybe limited. Instead the output can be redirected to a logging subsystem for example. Use of this module still requires the ezprofiler escript, but it will be automatically initialized in the background. ezprofiler can be downloaded from https://github.com/nhpip/ezprofiler or added to deps in mix.exs along with this package: defp deps do [ { :ezprofiler , git : &quot;https://github.com/nhpip/ezprofiler.git&quot; } , { :ezprofiler_deps , git : &quot;https://github.com/nhpip/ezprofiler_deps.git&quot; } ] end This profiling mechanism supports two modes of operation, blocking and non-blocking In blocking mode the user starts profiling and then calls a blocking function to wait for the results. In non-blocking mode the results are sent as a message, this will be a handle_info/2 in the case of a GenServer The results are a map or list of maps that contains: %{ type : type , # One of :normal or :pseudo label : label , # The label used by this run filename : filename , # The results file profiler : profiler , # &quot;eprof, &quot;fprof&quot;, &quot;cprof&quot; or :no_profiler in case of pseudo results_data : results # String containing the results } Blocking Example EZProfiler.Manager . start_ezprofiler ( % EZProfiler.Manager.Configure { ezprofiler_path : :deps } ) ... ... with :ok &lt;- EZProfiler.Manager . set_mgmt_mode_blocking ( ) ## Set before `enable_profiling/0` :ok &lt;- EZProfiler.Manager . enable_profiling ( ) , { :ok , run_results } &lt;- EZProfiler.Manager . wait_for_results ( ) , { :ok , results } &lt;- EZProfiler.Manager . get_profiling_results ( true ) do { :ok , results } else rsp -&gt; rsp end ... ... EZProfiler.Manager . stop_ezprofiler ( ) The function wait_for_results/1 will return the results of that current profiling run, whereas get_profiling_results/1 returns a list of results for that entire run (e.g. if label transition is selected). This is cleared if enable_profiling/1 or disable_profiling/0 is called Non-blocking Example as a GenServer ## Your handle_cast def handle_cast ( :start_profiling , state ) do EZProfiler.Manager . start_ezprofiler ( % EZProfiler.Manager.Configure { ezprofiler_path : :deps } ) EZProfiler.Manager . set_mgmt_mode_non_blocking ( ) ## Set before `enable_profiling/0` EZProfiler.Manager . enable_profiling ( ) { :noreply , state } end def handle_info ( { :ezprofiler_results , results } , state ) do EZProfiler.Manager . stop_ezprofiler ( ) # Don&#39;t have to stop if you don&#39;t want to do_something_with_results ( results . type , results . filename , results . results_data ) { :noreply , state } end ## Change timeout with `EZProfiler.Manager.profiling_time/1` def handle_info ( { :ezprofiler , :profiling_timeout } , state ) do # Ooops, but it&#39;s possible results are available { :ok , results } = EZProfiler.Manager . get_profiling_results ( ) { :noreply , state } end ## Change timeout with `EZProfiler.Manager.profiling_start_wait/1` def handle_info ( { :ezprofiler , :start_profiling_timeout } , state ) do # Ooops { :noreply , state } end Labels When using EZProfiler.Manager.enable_profiling/1 either a single label or a list of labels can be specified. In the case of a list there are two modes of operation, label transition ( labeltran ) true or label transition false (the default). The behavior is as follows: Label Transition false This effectively a request to profile one-of those labels. The first matching label is selected for profiling and the rest of the labels are ignored. Label Transition true In this case all specified labels shall be profiled sequentially (order doesn't matter), effectively the profiler automatically re-enables profiling after a label match. A label that matches and is profiled, will removed from the list of labels to be profiled next and profiling is re-enabled for the remaining labels. This allows profiling to follow the flow of code through your application, even if processes are switched. It is important to note that the rule of only one process at a time can be profiled still exists, so ideally profiled code calls should be sequential. However, if there are sections of code that need to be profiled that overlap in time ezprofiler performs pseudo profiling . This is where ezprofiler will calculate and display how long the profiled code took to execute. Use allow_label_transition/1 to configure label transition.","ref":"EZProfiler.Manager.html","title":"EZProfiler.Manager","type":"module"},{"doc":"If many labels are specified in enable_profiling/1 setting this to true will automatically re-enable profiling after one label has been profiled. Example EZProfiler.Manager . enable_profiling ( [ &quot;L1&quot; , &quot;L2&quot; , &quot;L3&quot; ] ) L1 is hit and profiled the next profile will be the equivalent of issuing: EZProfiler.Manager . enable_profiling ( [ &quot;L2&quot; , &quot;L3&quot; ] ) Then L2 hit: EZProfiler.Manager . enable_profiling ( [ &quot;L3&quot; ] ) This permits profiling a flow that may involve messages between a number of processes.","ref":"EZProfiler.Manager.html#allow_label_transition/1","title":"EZProfiler.Manager.allow_label_transition/1","type":"function"},{"doc":"Disables code profiling. The equivalent of hitting r in the CLI.","ref":"EZProfiler.Manager.html#disable_profiling/0","title":"EZProfiler.Manager.disable_profiling/0","type":"function"},{"doc":"Enables code profiling. The equivalent of hitting c or c label in the CLI. A single label, or list of labels can be specified","ref":"EZProfiler.Manager.html#enable_profiling/1","title":"EZProfiler.Manager.enable_profiling/1","type":"function"},{"doc":"Returns the resulting code profiling results. If the option display is set to true it will also output the stdout . On success it will return the tuple {:ok, results}","ref":"EZProfiler.Manager.html#get_profiling_results/1","title":"EZProfiler.Manager.get_profiling_results/1","type":"function"},{"doc":"Specifies how long we wait for profiling to actually start once enable_profiling/1 is issued. Time is specified in milliseconds or the atom :infinity , default :infinity","ref":"EZProfiler.Manager.html#profiling_start_wait/1","title":"EZProfiler.Manager.profiling_start_wait/1","type":"function"},{"doc":"Specifies how long we wait for profiling to actually complete once started. Time is specified in milliseconds.","ref":"EZProfiler.Manager.html#profiling_time/1","title":"EZProfiler.Manager.profiling_time/1","type":"function"},{"doc":"Sets the operating mode to blocking. This requires the user to make calls to EZProfiler.Manager.wait_for_results/0 and EZProfiler.Manager.get_profiling_results/0 to get the profiling results.","ref":"EZProfiler.Manager.html#set_mgmt_mode_blocking/0","title":"EZProfiler.Manager.set_mgmt_mode_blocking/0","type":"function"},{"doc":"Sets the operating mode to non-blocking. This will cause events from the profiler to be sent to the process id specified. If no process id is specified the result is sent to self() Three messages can be received: { :ezprofiler_results , result } { :ezprofiler , :profiling_timeout } { :ezprofiler , :start_profiling_timeout } Result is a map: %{ type : type , # One of :normal or :pseudo label : label , # The label used by this run filename : filename , # The results file profiler : profiler , # &quot;eprof, &quot;fprof&quot;, &quot;cprof&quot; or :no_profiler in case of pseudo results_data : results # String containing the results } In the case of a GenServer these will be received by handle_info/2 If {:error, :profiling_timeout} is returned results may still be available, call EZProfiler.Manager.get_profiling_results/0 to retrieve them.","ref":"EZProfiler.Manager.html#set_mgmt_mode_non_blocking/1","title":"EZProfiler.Manager.set_mgmt_mode_non_blocking/1","type":"function"},{"doc":"Starts and configures the ezprofiler escript. Takes the %EZProfiler.Manager.Configure{} struct as configuration. Most fields map directly onto the equivalent arguments for starting ezprofiler . The exception to this is ezprofiler_path that takes the following options: :system - if ` ezprofiler ` is defined via the ` PATH ` env variable . :deps - if ` ezprofiler ` is included as a dependency in ` mix . exs ` path - a string specifying the full path for ` ezprofiler ` Example % EZProfiler.Manager.Configure { cookie : nil , cpfo : &quot;false&quot; , directory : &quot;/tmp/&quot; , ezprofiler_path : :system , mf : &quot;_:_&quot; , node : nil , profiler : &quot;eprof&quot; , labeltran : true , sort : &quot;mfa&quot; }","ref":"EZProfiler.Manager.html#start_ezprofiler/1","title":"EZProfiler.Manager.start_ezprofiler/1","type":"function"},{"doc":"Stops the ezprofiler escript. The equivalent of hitting q in the CLI.","ref":"EZProfiler.Manager.html#stop_ezprofiler/0","title":"EZProfiler.Manager.stop_ezprofiler/0","type":"function"},{"doc":"Waits timeout milliseconds (default 5000) for any results and returns the result as a map. %{ type : type , # One of :normal or :pseudo label : label , # The label used by this run filename : filename , # The results file profiler : profiler , # &quot;eprof, &quot;fprof&quot;, &quot;cprof&quot; or :no_profiler in case of pseudo results_data : results # String containing the results } If {:error, :profiling_timeout} is returned results may still be available, call EZProfiler.Manager.get_profiling_results() to retrieve them","ref":"EZProfiler.Manager.html#wait_for_results/1","title":"EZProfiler.Manager.wait_for_results/1","type":"function"},{"doc":"","ref":"EZProfiler.Manager.html#wait_for_results_non_block/1","title":"EZProfiler.Manager.wait_for_results_non_block/1","type":"function"},{"doc":"","ref":"EZProfiler.Manager.html#t:display/0","title":"EZProfiler.Manager.display/0","type":"type"},{"doc":"","ref":"EZProfiler.Manager.html#t:filename/0","title":"EZProfiler.Manager.filename/0","type":"type"},{"doc":"","ref":"EZProfiler.Manager.html#t:label/0","title":"EZProfiler.Manager.label/0","type":"type"},{"doc":"","ref":"EZProfiler.Manager.html#t:labels/0","title":"EZProfiler.Manager.labels/0","type":"type"},{"doc":"","ref":"EZProfiler.Manager.html#t:profile_data/0","title":"EZProfiler.Manager.profile_data/0","type":"type"},{"doc":"","ref":"EZProfiler.Manager.html#t:profiling_cfg/0","title":"EZProfiler.Manager.profiling_cfg/0","type":"type"},{"doc":"","ref":"EZProfiler.Manager.html#t:profiling_time/0","title":"EZProfiler.Manager.profiling_time/0","type":"type"},{"doc":"","ref":"EZProfiler.Manager.html#t:result/0","title":"EZProfiler.Manager.result/0","type":"type"},{"doc":"","ref":"EZProfiler.Manager.html#t:results/0","title":"EZProfiler.Manager.results/0","type":"type"},{"doc":"","ref":"EZProfiler.Manager.html#t:self/0","title":"EZProfiler.Manager.self/0","type":"type"},{"doc":"","ref":"EZProfiler.Manager.html#t:wait_time/0","title":"EZProfiler.Manager.wait_time/0","type":"type"},{"doc":"The configuration struct for code based code-profiling.","ref":"EZProfiler.Manager.Configure.html","title":"EZProfiler.Manager.Configure","type":"module"},{"doc":"","ref":"EZProfiler.Manager.Configure.html#t:t/0","title":"EZProfiler.Manager.Configure.t/0","type":"type"}]